HDU3342(拓扑排序找环)

题目

http://acm.hdu.edu.cn/showproblem.php?pid=3342

  • Problem Description
    ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many “holy cows” like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost “master”, and Lost will have a nice “prentice”. By and by, there are many pairs of “master and prentice”. But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

    We all know a master can have many prentices and a prentice may have a lot of masters too, it’s legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian’s master and, at the same time, 3xian is HH’s master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not.

    Please note that the “master and prentice” relation is transitive. It means that if A is B’s master ans B is C’s master, then A is C’s master.

  • Input
    The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y’s master and y is x’s prentice. The input is terminated by N = 0.
    TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,…, N-1). We use their numbers instead of their names.

  • Output
    For each test case, print in one line the judgement of the messy relationship.
    If it is legal, output “YES”, otherwise “NO”.

  • Sample Input
    3 2
    0 1
    1 2
    2 2
    0 1
    1 0
    0 0

  • Sample Output
    YES
    NO

题意

每个人都可以有多个师傅,并且师徒关系是可以传递的,即我师傅的师傅也是我的师傅,我徒弟的徒弟也是我的徒弟
自己的徒弟如果是自己的师傅,输出NO
如果全部合法则输出YES

思路

记录每个人的师傅数量,即每个人的入度.
循环,每次都遍历所有人,将师傅数量为0的结点删除,并减少指向的结点的师傅数量,直到无法再删除任何结点.
如果有环,即自己的徒弟是自己的师傅,则最后会有结点的入度不为0,因为互相是对方的师傅.
所以如果无环,则最后所有人的入度都为0.

代码

#include 
#include 
using namespace std;

bool m[105][105];//数据比较少,邻接矩阵方便一点
int master[105];

int main() {
    int n,M,u,v;
    while(scanf("%d%d",&n,&M)!=EOF and n) {
        memset(master,0,sizeof(master));
        memset(m,false,sizeof(m));
        while(M--) {
            scanf("%d%d",&u,&v);
            if(!m[u][v]) {
                m[u][v]=true;
                ++master[v];
            }
        }

        bool flag;
        int num=0;//人数
        for(;;) {
            flag=true;
            for(int u=0; u<n; ++u) { //找出master数量为0的人
                if(master[u]==0) {
                    ++num;
                    master[u]=-1;
                    flag = false;
                    for(int v=0; v<n; ++v) {
                        if(m[u][v])
                            --master[v];
                    //减去master数量为0的人指向的徒弟的师傅数量
                    }
                }
            }
            if(flag)break;
        }

        if(num==n)
            printf("YES\n");
        else
            printf("NO\n");
    }
    return 0;
}

你可能感兴趣的:(HDU3342(拓扑排序找环))